;=========================================================
;writes to exe (in memory; does not modify exe file)
;=========================================================
write_exe_proc: 	;edx=destination addr
			;ecx=source addr
			;esi=number of bytes to write
			;eax=addr of var to check for use or not (0 if none)
			;    (if [var] is null, no write is performed)
			;edi=log file message pointer
			;returns 1 in edi if write failed (use "test edi,1" for test)
	push edi	;used by "call WriteLogFile"
	test eax,eax
	mov edi,2
	     jz no_write_exe_var_check
	cmp DWORD [eax],0
	    jz no_write_exe_var_null
no_write_exe_var_check:
	push 0
invoke WriteProcessMemory,ebx,edx,ecx,esi,esp
	pop ecx
	xor edi,edi
	test eax,eax
	     jnz write_exe_call_ok
	     or edi,1
	     write_exe_call_ok:
	cmp ecx,esi
	     jz write_exe_bytes_ok
	     or edi,1
	     write_exe_bytes_ok:

	or [DLLLoadSuccessBool],edi
	no_write_exe_var_null:
	push edi
	call WriteLogFile		;param 1 already pushed
ret

;==========================================================
CreateLogFile:
;==========================================================
push ebx
invoke CreateFile,LogFileName,GENERIC_WRITE,0,0,CREATE_ALWAYS,\
	FILE_ATTRIBUTE_NORMAL,0
	cmp eax,-1
	     jz CreateLogFile_ERROR
	mov ebx,eax
invoke SetFilePointer,eax,0,0,FILE_BEGIN

	sub esp,4
	mov ecx,esp
invoke WriteFile,ebx,_log_title,(end_log_title-_log_title),ecx,0
	add esp,4
	test eax,eax
	     jz CreateLogFile_ERROR_2

invoke CloseHandle,ebx
pop ebx
ret

CreateLogFile_ERROR_2:
invoke CloseHandle,ebx
CreateLogFile_ERROR:
or [DLLLoadSuccessBool],1
pop ebx
ret

;==========================================================
WriteLogFile:	 ;[esp+4]=0-SUCCESS,1-FAIL,2-N/A; [esp+8]=string to print
;==========================================================
cmp DWORD [esp+8],0
    jz NoWriteLogFile_A

push eax
push ecx
push edx
push ebx
push edi

invoke CreateFile,LogFileName,GENERIC_WRITE,0,0,OPEN_ALWAYS,\
	FILE_ATTRIBUTE_NORMAL,0
	cmp eax,-1
	    jz WriteLogFile_ERROR
	mov ebx,eax

invoke SetFilePointer,eax,0,0,FILE_END

	mov edi,[esp+28]
	xor al,al
	or ecx,0FFFFFFFFh
	repnz scasb
	dec edi
	mov eax,[esp+28]
	sub esp,4
	sub edi,eax
	mov ecx,esp
invoke WriteFile,ebx,eax,edi,ecx,0
	add esp,4
	test eax,eax
	     jz WriteLogFile_ERROR_2

	mov eax,[esp+24]
	mov edi,_log_pass
	test eax,eax
	     jz pass_test_jump
		mov edi,_log_fail
		cmp eax,1
		    jz fail_test_jump
		mov edi,_log_na
		fail_test_jump:
	pass_test_jump:

	sub esp,4
	mov ecx,esp
invoke WriteFile,ebx,edi,12,ecx,0
	add esp,4
	test eax,eax
	     jz WriteLogFile_ERROR_2

invoke CloseHandle,ebx
pop edi
pop ebx
pop edx
pop ecx
pop eax
NoWriteLogFile_A:
ret 8

WriteLogFile_ERROR_2:
invoke CloseHandle,ebx
WriteLogFile_ERROR:
or [DLLLoadSuccessBool],1
pop edi
pop ebx
pop edx
pop ecx
pop eax
ret 8

;==========================================================
find_replace_cheat:
;==========================================================
			;[esp+4]=pointer to cheat name
			;[esp+8]=log message
			;[esp+12]=cheat main proc
	xor ebp,ebp
	mov ecx,[OriginalCheats]
	lea edx,[ecx*8+Cheattable]

	SCANFORCHEAT_LOOP:
	sub edx,8
	mov edi,[edx]
	mov esi,[esp+4]
	    COMP_CHEAT_NAMES_LOOP:
	    mov al,[esi]
	    cmp al,[edi]
		jnz CHEAT_NOT_FOUND
	    test al,al
		jz CHEAT_NAME_FOUND
	    inc esi
	    inc edi
	    jmp COMP_CHEAT_NAMES_LOOP
	CHEAT_NOT_FOUND:
	loop SCANFORCHEAT_LOOP

	or ebp,1
	CHEAT_NAME_FOUND:

	test ecx,ecx
	     jz NO_CHEAT_INDEX_REPLACE
	dec ecx
	mov eax,[esp+12]
	mov DWORD [ecx*4+CHEATJUMPINDEX],eax
	NO_CHEAT_INDEX_REPLACE:

	mov edx,[esp+8]
	WRITELOG edx,ebp
ret 12