;=======================================================
;Pre-level load function
;=======================================================
;These function are called PRECEDING the main game "level load" call
;They are used before ALL level loads, including restarts
;and savegames. If a breakpoint is placed in one of these, it will typically
;halt loading with the progress bar at 0%.

;DO NOT RELY ON STACK - ALREADY NEAR LIMIT

;=======================================================
Modify_External_PreLoad:	 ;eax, ecx, edx may be destroyed
;=======================================================
;(called AFTER FastLoadInterceptProc)

;----------------------------
;RESET FOG COLOR SET ONCE BOOL (FOR NIGHT MODE, IN CASE COLOR HAS NOT BEEN SET PROPERLY)
;----------------------------
     mov [AT05FogWithColorModRunOnceInLevel],FALSE

;----------------------------
;GET CPARTICLES NAMES IDS USING EXE FUNCTION
;----------------------------
     call CParticlesInitTypeIDTable

;----------------------------
;RESET AT109 DEFAULT COLOR CHANGE BUFFER
;----------------------------
     call CParticlesResetAT109Buffer

;----------------------------
;RESET CPARTICLES COLOR SPAN (FOR NIGHT MODE)
;----------------------------
     call CParticlesResetMaxColorsBuffer

cmp [NIGHT_enabled],FALSE
    jz NoCParticlesSetUniMaskSelective_NIGHT
	mov eax,[NIGHT_CParticlesColorMax]
	mov edx,[NIGHT_CParticlesTypes]
	call CParticlesSetUniMaskSelective
NoCParticlesSetUniMaskSelective_NIGHT:

;----------------------------
;SET 2D MAP NOT YET LOADED BOOL
;----------------------------
     mov [MapLoadSuccess_BOOL],FALSE

;----------------------------
;RELEASE CURRENT NEW HINT STRING (IF EXISTS)
;----------------------------
     LOCALRELEASE [HINT_NEW_STRING_ADDR]

;----------------------------
;SET ORIGINAL GAME SPEED (IN CASE MODIFIED BY LEVEL VIA AT101 OR BY MXT)
;----------------------------
     mov eax,[OrigNormalGameSpeed]
     mov edx,[GameSpeedVarADDR]
     mov [NormalGameSpeed],eax
     cmp [BIONICWOMAN_enabled],1
	 jnz SetInitialGameSpeedNOTBIONICWOMAN
	 mov eax,[DefaultSlowSpeed]
     SetInitialGameSpeedNOTBIONICWOMAN:
     mov [edx],eax
     mov [MXTStateEnabled],0

;----------------------------
;SET DEFAULT HINT STRING (IN CASE NONE LOADED)
;----------------------------
     mov eax,[CURRENT_HINT_ID_ADDR]
     mov [eax],DWORD DEFAULT_HINT_ID

;----------------------------
;/* REPLACED CODE
mov ecx, DWORD [esp+00000618h]		;original code was +0614h, but must include return address
;*/
ret

;=======================================================
FastLoadInterceptProc:	  ;eax, ecx, edx may be destroyed
;=======================================================
;Boolean at BYTE [esp+10h] (excluding return address for this proc call)
;Set to FALSE to disable using GRF data from last load (re-load)

pop ecx  ;return address

;NIGHT MODE NOFASTLOAD CHECK
      mov eax,[NIGHT_enabled]
      cmp eax,[NIGHT_enabled_last]
      mov [NIGHT_enabled_last],eax
	  jz NoDisableFastLoad_NIGHT
	  mov BYTE [esp+10h],0		;Toggling the NIGHT cheat must cause new GRF load for GlobalClut
      NoDisableFastLoad_NIGHT:

;STANDARD NOFASTLOAD CHECK
      cmp [DisableFastLoad],FALSE
	  jz NoDisableFastLoad_A
	  mov BYTE [esp+10h],0
      NoDisableFastLoad_A:

;TELL ATX IF THE LEVEL THAT IS BEING LOADED IS TO BE A NEW GRF LOAD/SCAN
;OR A LEVEL RESTART BASED ON THE SAME GRF

      mov al,[esp+10h]
      xor al,1
      mov [NewGRFLoadDetected],al

;/* REPLACED CODE
mov al,[esp+10h]
pop edi
test al,al	      ;DO NOT MODIFY FLAGS PAST THIS POINT
pop ebp
pop ebx
;*/
jmp ecx
