;=====================================================
;VARIOUS PROCEDURES
;=====================================================
;Note: for some of the 3D procedures, the fcos instruction is
;uselessly followed by a fabs (absolute value) instruction, which
;is unnecessary due to nature of cosine.
;Note2: Generally, "STD" is short for "Standard".

;============================================================
VirtualProtectNOEX:
;============================================================
	mov eax,[esp]		;return address
	add esp,4		;remove return address
	mov [esp],eax		;replace first param (process handle) with address
	jmp [VirtualProtect]


;============================================================
GetTickCountINGAME:	   ;returns tick count from level start
;============================================================
;returns tick count, but substracts total time spent in in-game menu
;from tick

	invoke GetTickCountTRUE
	sub eax,[NotInGame_TOTALMENUTIME]
	sub eax,[LevelStart_TICK]
ret

;============================================================
StartInGameMenuTimer:
;============================================================
;only starts timer if not already not in-game (if in-game)
cmp [IsInGame_BOOL],0		  ;only start not-in-game tick if previously in-game
    jz NoStartInGameMenuTimer

push eax
push ecx
push edx
	invoke GetTickCountTRUE
	mov [NotInGameStart_TICK],eax
	mov [NotInGame_BOOL],1
pop edx
pop ecx
pop eax
NoStartInGameMenuTimer:
ret

;============================================================
IsPlayerHoldingCGun:  ;destroyed: eax,edx, returns 0 if false or CGun object otherwise
;============================================================
	mov eax,[ActiveGunRef]
	mov edx,[eax]
	mov eax,[edx]
	mov edx,[eax+08h]
	mov eax,[edx+0E34h]	;eax = possible primary CGun object (object held by Anne)
	test eax,eax
	mov edx,[CGUNVTABLE]
	     jz IsPlayerHoldingCGunEXIT     ;make sure player is holding an object
	cmp [eax],edx
	    jz IsPlayerHoldingCGunEXIT
	xor eax,eax
IsPlayerHoldingCGunEXIT:
ret

;============================================================
GetCPlayerPrivInstance: 	;destroyed: ecx only, returns in ecx
;============================================================
       mov ecx,[PLAYER_OBJ_INVUL_ADDR]
       mov ecx,[ecx]
ret

;============================================================
GetInstanceFromString:	 ;eax = instance's name, returns in eax (null if error)
;============================================================
;THIS FUNCTION IS COPIED ALMOST ENTIRELY FROM THE EXECUTABLE.
;IT IS POORLY CODED, BUT MOSTLY UNCHANGED FOR COMPATIBILITY
;WITH MAIN FUNCTION.
;GetInstanceFromStringGlobal should generally be used instead.

push esi
push ecx
push edx

     mov esi,eax
     push 16
     call [YAPAXI]
     add esp,4
     test eax,eax
	  jz GETINST_MEM1_NOTOK
     push [GETINST_ADDR1]
     mov ecx,eax
     call [GETINST_PROC1]
     jmp GETINST_MEM1_OK
	 GETINST_MEM1_NOTOK:
	 xor eax,eax
     GETINST_MEM1_OK:

     push eax
     push 0
     sub esp,8
     mov ecx,esp
     push esi
     call [GETINST_PROC2]
     mov eax,[GETINST_ADDR2]
     mov edx,[eax]
     mov ecx,[edx+4]
     call [GETINST_PROC3]      ;takes 4 parameters (push eax; push 0; sub esp,8)

pop edx
pop ecx
pop esi
ret

;============================================================
GetDDrawObject: 	;returns in eax (should be NULL if none)
;============================================================
push ecx
     mov ecx,[DDRAW_OBJ_BASE]
     mov eax,[ecx+4]
     test eax,eax
	  jnz D3D_DDraw_Object_Found
     mov eax,[ecx]			;(software mode otherwise)
     D3D_DDraw_Object_Found:
pop ecx
ret

;============================================================
CompareStrings: 	;ecx=string1, edx=string2 ; ignores case
;============================================================
			;returns FALSE if not same, edx and ecx point to null-terminators
CompareStringsLoop: ;edi points to dest.'s null-terminator (BYTE [edi] = 0)
     mov al,[ecx]
     mov ah,[edx]	       ;transfer/append string
     CHAR_TOLOWERCASE al
     CHAR_TOLOWERCASE ah
     cmp ah,al
	 jnz StringsNotSame
     test al,al
	  jz StringsSame
     inc ecx
     inc edx
     jmp CompareStringsLoop
StringsSame:
     mov eax,TRUE
ret

StringsNotSame:
     xor eax,eax
ret

;============================================================
TransferString: 	;esi=source, edi=dest., destroyed: esi,edi, al
;============================================================
TransferStringLoop: ;edi points to dest.'s null-terminator (BYTE [edi] = 0)
     mov al,[esi]
     mov [edi],al	      ;transfer/append string
     test al,al
	  jz End_TransferStringLoop
     inc esi
     inc edi
     jmp TransferStringLoop
End_TransferStringLoop:
ret

;============================================================
DisableInGameMvtKeys:
;============================================================
push edx
push eax
     mov edx,[KEY_LIST_ADDR]
     xor eax,eax
     mov [edx+4+(5*8)],eax    ;jump
     mov [edx+4+(10*8)],eax   ;run
     mov [edx+4+(11*8)],eax   ;walk
     mov [edx+4+(12*8)],eax   ;backward
     mov [edx+4+(13*8)],eax   ;left
     mov [edx+4+(14*8)],eax   ;right

pop eax
pop edx
ret

;============================================================
DisableInGameKeys:	      ;includes mouse clicks
;============================================================
push eax
push edx
push esi
     mov edx,[KEY_LIST_ADDR]
     lea esi,[edx+15*8]
     add edx,4
     xor eax,eax

     DisableInGameKeys_Loop:
     mov [edx],eax
     add edx,8
     cmp edx,esi
     jb DisableInGameKeys_Loop

pop esi
pop edx
pop eax
ret

;============================================================
EnableInGameKeys:	       ;includes mouse clicks
;============================================================
push eax
push edx
push esi
     mov edx,[KEY_LIST_ADDR]
     mov esi,DefaultKeyBOOLS
     add edx,4

     EnableInGameKeys_Loop:
     mov eax,[esi]
     mov [edx],eax
     add edx,8
     add esi,4
     cmp esi,DefaultKeyBOOLS_END
     jb EnableInGameKeys_Loop

pop esi
pop edx
pop eax
ret


;============================================================
RANDOMIZE_RANDOM_PROC:
;============================================================
invoke time,0
invoke srand,eax
add esp,8
ret

;============================================================
GetRandomNumber:	;[esp+4] = below or equal to this number and not zero
;============================================================
invoke rand
mov ecx,[esp+4]
test ecx,ecx
     jz GetRandom_DivideByZero
xor edx,edx		;parameter must NOT be null
div ecx 		;(note: I didn't think of this)
mov eax,edx		;remainder
add eax,1
ret 4			;returns number in eax (0 if param was null)

GetRandom_DivideByZero:
xor eax,eax
ret 4

;============================================================
IsLevelSavedGame:	;returns 0 if false, non-zero if true
;============================================================
;NOTE: If a Level Restart was performed before last load,
;      automatically NOT a saved game.
push edi
push ecx
push esi

	or ecx,0FFFFFFFFh
	mov edi,[LEVELNAME_OBJ]
	add edi,20
	xor eax,eax
	repnz scasb

	cmp DWORD [edi-5],'.SCN'
	    jz LevelNotSavedGame
	cmp DWORD [edi-5],'.scn'
	    jz LevelNotSavedGame
	cmp [Restart_Exit_Level_BOOL],1
	    jz LevelNotSavedGame
	or al,1
	LevelNotSavedGame:

pop esi
pop ecx
pop edi
ret

;============================================================
IsLevelSavedGameAbsolute:	;returns 0 if false, non-zero if true
;============================================================
;NOTE: Does not take into account level restarts (source *.scn
;      or savegame name only)
push edi
push ecx
push esi

	or ecx,0FFFFFFFFh
	mov edi,[LEVELNAME_OBJ]
	add edi,20
	xor eax,eax
	repnz scasb

	cmp DWORD [edi-5],'.SCN'
	    jz LevelNotSavedGameAbs
	cmp DWORD [edi-5],'.scn'
	    jz LevelNotSavedGameAbs
	or al,1
	LevelNotSavedGameAbs:

pop esi
pop ecx
pop edi
ret

;============================================================
	GetPrivateProfileFloat	dd	GetINIFloat
;============================================================
GetINIFloat:	;returns 32-bit float in eax (null if doesn't exist or if 0)
;============================================================
;[esp+4]=points to section name
;[esp+8]=points to key name
;[esp+12]=default string if none found (pointer)
;[esp+16]=points to INI filename
push ebp
mov ebp,esp
sub esp,104

	lea edx,[ebp-100]
invoke GetPrivateProfileString,[ebp+8],[ebp+12],[ebp+16],edx,\
		100,[ebp+20]

	lea edx,[ebp-104]
	lea eax,[ebp-100]

	cmp BYTE [eax],';'
	    jnz NoEmptyFloatEntry2
	    mov eax,[ebp+16]
	    jmp NoEmptyFloatEntry
	NoEmptyFloatEntry2:

	cmp BYTE [eax],0
	    jnz NoEmptyFloatEntry
	    mov eax,[ebp+16]
	NoEmptyFloatEntry:

invoke sscanf,eax,_float,edx
	add esp,12

	pop eax
mov esp,ebp
pop ebp
ret 16

;============================================================
;Quaternion multiplication (eax=q1, ecx=q2, edx=result)
;============================================================

virtual at eax
	w1	dd	?
	x1	dd	?
	y1	dd	?
	z1	dd	?
end virtual

virtual at ecx
	w2	dd	?
	x2	dd	?
	y2	dd	?
	z2	dd	?
end virtual

;(Q1 * Q2).w = (w1w2 - x1x2 - y1y2 - z1z2)
;(Q1 * Q2).x = (w1x2 + x1w2 + y1z2 - z1y2)
;(Q1 * Q2).y = (w1y2 - x1z2 + y1w2 + z1x2)
;(Q1 * Q2).z = (w1z2 + x1y2 - y1x2 + z1w2)

QuaternionMul_STD:	  ;eax=q1 , ecx=q2, edx=new quat
;------------- w
	fld [w1]
	fmul [w2]

	fld [x1]
	fmul [x2]
	fsubp st1,st0

	fld [y1]
	fmul [y2]
	fsubp st1,st0

	fld [z1]
	fmul [z2]
	fsubp st1,st0
	fstp DWORD [edx]

;------------- x
	fld [w1]
	fmul [x2]

	fld [x1]
	fmul [w2]
	faddp st1,st0

	fld [y1]
	fmul [z2]
	faddp st1,st0

	fld [z1]
	fmul [y2]
	fsubp st1,st0
	fstp DWORD [edx+4]

;------------- y
	fld [w1]
	fmul [y2]

	fld [x1]
	fmul [z2]
	fsubp st1,st0

	fld [y1]
	fmul [w2]
	faddp st1,st0

	fld [z1]
	fmul [x2]
	faddp st1,st0
	fstp DWORD [edx+8]

;------------- z
	fld [w1]
	fmul [z2]

	fld [x1]
	fmul [y2]
	faddp st1,st0

	fld [y1]
	fmul [x2]
	fsubp st1,st0

	fld [z1]
	fmul [w2]
	faddp st1,st0
	fstp DWORD [edx+12]

ret


;Note: I don't know if you need to normalize locally-generated quaternions. I believe
;not, but I'm leaving it here nevertheless because I'm no expert and I don't want
;to risk messing up any existing features.
;============================================================
ToLocalQuat_AxisX_STD:	  ;ecx=pointer to radian angle to rotate by, edx=local_rotation pointer wxyz
;============================================================
				;axis.x = 1.00000 , axis.y=0.0000, axis.z=0.00000
	fld DWORD [ecx]
	fmul [float_0_5]
	fld st0
	fsin
	fst DWORD [edx+4]	;x
	fmul st0,st0

	fxch
	fcos
	fst DWORD [edx] 	;w
	fmul st0,st0
	faddp st1,st0

	fsqrt			;magnitude
	xor eax,eax
	fdivr [float_one]	;1/magnitude
	fld st0

	fmul DWORD [edx]	;normalize w
	      mov [edx+8],eax	;y
	fstp DWORD [edx]
	fmul DWORD [edx+4]	;normalize x
	      mov [edx+12],eax	;z
	fstp DWORD [edx+4]

ret

;============================================================
ToLocalQuat_AxisY_STD:	  ;ecx=pointer to radian angle to rotate by, edx=local_rotation pointer wxyz
;============================================================
				;axis.x = 0.00000 , axis.y=1.0000, axis.z=0.00000
	fld DWORD [ecx]
	fmul [float_0_5]
	fld st0
	fsin
	fst DWORD [edx+8]	;y
	fmul st0,st0

	fxch
	fcos
	fst DWORD [edx] 	;w
	fmul st0,st0
	faddp st1,st0

	fsqrt			;magnitude
	xor eax,eax
	fdivr [float_one]	;1/magnitude
	fld st0

	fmul DWORD [edx]	;normalize w
	      mov [edx+4],eax	;x
	fstp DWORD [edx]
	fmul DWORD [edx+8]	;normalize y
	      mov [edx+12],eax	;z
	fstp DWORD [edx+8]

ret

;============================================================
ToLocalQuat_AxisZ_STD:	  ;ecx=pointer to radian angle to rotate by, edx=local_rotation pointer wxyz
;============================================================
				;axis.x = 0.00000 , axis.y=0.0000, axis.z=1.00000
	fld DWORD [ecx]
	fmul [float_0_5]
	fld st0
	fsin
	fst DWORD [edx+12]	 ;z
	fmul st0,st0

	fxch
	fcos
	fst DWORD [edx] 	;w
	fmul st0,st0
	faddp st1,st0

	fsqrt			;magnitude
	xor eax,eax
	fdivr [float_one]	;1/magnitude
	fld st0

	fmul DWORD [edx]	;normalize w
	      mov [edx+8],eax	;y
	fstp DWORD [edx]
	fmul DWORD [edx+12]	;normalize z
	      mov [edx+4],eax	;x
	fstp DWORD [edx+12]

ret

;============================================================
ToLocalQuat_AxisX_NoNorm_STD:	 ;ecx=pointer to radian angle to rotate by, edx=local_rotation pointer wxyz
;============================================================
				;axis.x = 1.00000 , axis.y=0.0000, axis.z=0.00000
	fld DWORD [ecx]
	fmul [float_0_5]
	xor eax,eax
	fsincos
	mov DWORD [edx+8],eax
	mov DWORD [edx+12],eax
	fstp DWORD [edx]
	fstp DWORD [edx+4]

ret

;============================================================
ToLocalQuat_AxisY_NoNorm_STD:	 ;ecx=pointer to radian angle to rotate by, edx=local_rotation pointer wxyz
;============================================================
				;axis.x = 0.00000 , axis.y=1.0000, axis.z=0.00000
	fld DWORD [ecx]
	fmul [float_0_5]
	xor eax,eax
	fsincos
	mov DWORD [edx+4],eax
	mov DWORD [edx+12],eax
	fstp DWORD [edx]
	fstp DWORD [edx+8]

ret

;============================================================
ToLocalQuat_AxisZ_NoNorm_STD:	 ;ecx=pointer to radian angle to rotate by, edx=local_rotation pointer wxyz
;============================================================
				;axis.x = 0.00000 , axis.y=0.0000, axis.z=1.00000
	fld DWORD [ecx]
	fmul [float_0_5]
	xor eax,eax
	fsincos
	mov DWORD [edx+4],eax
	mov DWORD [edx+8],eax
	fstp DWORD [edx]
	fstp DWORD [edx+12]

ret

;============================================================
QuatToAxisAngle_STD:	    ;eax = w,x,y,z quat ;ecx = angle+axis (angle in radians, axisx, axisy, axisz)
;============================================================
sub esp,16
	mov edx,[eax]
	mov [esp],edx
	mov edx,[eax+4]
	mov [esp+4],edx
	mov edx,[eax+8]
	mov [esp+8],edx
	mov edx,[eax+12]
	mov [esp+12],edx
	mov eax,esp
	call NormalizeQuat

	fld DWORD [eax] 	;cos
	fmul st0,st0
	fsubr [float_one]
	fsqrt			;sin = sqrt(1.0-cos^2)
	fld st0
	fld DWORD [eax]
	fpatan			;acos = tan_-1 (sin/cos)
	fmul [float_two]	;angle = acos*2
	fstp DWORD [ecx]

	fld st0
	fabs
	fcomp [float_0_0005]	 ;sin now in st0
	push eax
	fstsw ax
	test eax,100h		;sin < 0.0005 ?
	     jz sinnotbelow0_0005
	     fstp st0
	     fld1		;if so, sin = 1.000000
	     sinnotbelow0_0005:
	pop eax

	fdivr [float_one]	;1/sin

	fld DWORD [eax+4]	;x
	fmul st0,st1		;x/sin
	fstp DWORD [ecx+4]	;axisx

	fld DWORD [eax+8]	;y
	fmul st0,st1		;y/sin
	fstp DWORD [ecx+8]	;axisy

	fld DWORD [eax+12]	;z
	fmul st0,st1		;z/sin
	fstp DWORD [ecx+12]	;axisz

	fstp st0

add esp,16
ret

;============================================================
NormalizeQuat_STD:	    ;eax = quat (w,x,y,z)
;============================================================
	fld DWORD [eax]
	fmul st0,st0
	fld DWORD [eax+4]
	fmul st0,st0
	fld DWORD [eax+8]
	fmul st0,st0
	fld DWORD [eax+12]
	fmul st0,st0
	faddp
	faddp
	faddp
	fsqrt

	fdivr [float_one]

	fld st0
	fmul DWORD [eax]
	fstp DWORD [eax]
	fld st0
	fmul DWORD [eax+4]
	fstp DWORD [eax+4]
	fld st0
	fmul DWORD [eax+8]
	fstp DWORD [eax+8]

	fmul DWORD [eax+12]
	fstp DWORD [eax+12]

ret

;============================================================
CONVERT_TO_FACING_PROC_2A_STD:	   ;[esp+4] = destvar, [esp+8]=param2, source quat=ecx
;============================================================
;
;CONVERT_TO_FACING_PROC:
; - quaternion to convert in ecx (w = c0, x = c4, y = c8, z = cC)
; - param2 put into eax in original function ([eax+00h] = a0, [eax+04h] = a4, [eax+08h] = a8)
; - final values put into destvar (first parameter)
; - original function uses local mem to store data (4 DWORDs at esp)
; - qword constant or var stored in EXE used once (referred to as q); should be 0.500000
;
; -> new function uses edx for param2 and eax for destvar, because destvar must
;    be returned in eax anyway


virtual at ecx
	c0	dd	?
	c4	dd	?
	c8	dd	?
	cC	dd	?
end virtual

virtual at edx
	a0	dd	?
	a4	dd	?
	a8	dd	?
end virtual

	fld DWORD [c0]
	fmul st0,st0
	mov eax,[CONVERTTOFACING_VAR1]
	fsub qword [eax]	 ;q (var or constant)

	fld [c0]
	fmul [cC]
	fld [c0]
	fmul [c8]
	fld [c4]
	fmul [cC]
	fld [c0]
	fmul [c4]

	fld [c8]
	fmul [cC]		;st2 when full stack

	fld [c4]
	fmul [c8]
	mov edx,[esp+8]
	mov eax,[esp+4]
	fstp DWORD [esp-4]     ;(c4*c8)

;DWORD [destvar+00h] = [eax] = [esp+04h] (originally)
;          = ((c4^2+(c0^2-q))*a0 + (c4*c8-c0*cC)*a4 + (c0*c8+c4*cC)*a8)*2

	fld [c4]
	fmul st0,st0
	fadd st0,st6
	fmul [a0]

	fld DWORD [esp-4]
	fsub st0,st6
	fmul [a4]
	faddp st1,st0

	fld st4
	fadd st0,st4
	fmul [a8]
	faddp st1,st0
	fadd st0,st0
	fstp DWORD [eax]

;DWORD [destvar+04h] = [eax+4] = [esp+08h] (originally)
;          = ((c8^2+(c0^2-q))*a4 + (c8*cC-c0*c4)*a8 + (c0*cC+c4*c8)*a0)*2

	fld [c8]
	fmul st0,st0
	fadd st0,st6
	fmul [a4]

	fld st1
	fsub st0,st3
	fmul [a8]
	faddp st1,st0

	fld DWORD [esp-4]
	fadd st0,st6
	fmul [a0]
	faddp st1,st0
	fadd st0,st0
	fstp DWORD [eax+4]

;DWORD [destvar+08h] = [eax+8] = [esp+0Ch] (originally)
;          = ((cC^2+(c0^2-q))*a8 + (c4*cC-c0*c8)*a0 + (c0*c4+c8*cC)*a4)*2

	faddp st1,st0		;c0*c4+c8*cC
	fmul [a4]
	fxch st2
	fsubp st1,st0		;c4*cC-c0*c8
	fmul [a0]
	faddp st1,st0

	fld [cC]
	fmul st0,st0
	fadd st0,st3
	fmul [a8]

	fxch st2
	fstp st0
	faddp st1,st0
	fadd st0,st0
	fxch st1
	fstp st0
	fstp DWORD [eax+8]


ret 8

;============================================================
CONVERT_TO_FACING_PROC_010_STD:      ;[esp+4] = destvar. (eax), [esp+8] = (unused) , ecx = quat
;============================================================
;This is used when the first param points to:
; DWORD 0.000000, DWORD 1.000000, DWORD 0.000000
;This is standard axis data (I believe), used for LOC cheat facing values,
;FLY cheat and others. Parameters are preserved for future implementation
;and compatibility.

;[destvar+00h] = ((c4^2+(c0^2-q))*a0 + (c4*c8-c0*cC)*a4 + (c0*c8+c4*cC)*a8)*2
;[destvar+04h] = ((c8^2+(c0^2-q))*a4 + (c8*cC-c0*c4)*a8 + (c0*cC+c4*c8)*a0)*2
;[destvar+08h] = ((cC^2+(c0^2-q))*a8 + (c4*cC-c0*c8)*a0 + (c0*c4+c8*cC)*a4)*2
;Where a0 = 0.000000, a4 = 1.000000, a8 = 0.000000
;Result (faster!):
;[destvar+00h] = (c4*c8-c0*cC)*2     (X facing value)
;[destvar+04h] = (c8^2+(c0^2-q))*2   (Y facing value)
;[destvar+08h] = (c0*c4+c8*cC)*2     (Z facing value)

	mov eax,[esp+4]
	fld [cC]
	fld [c8]
	fld [c4]
	fld [c0]

	fld st0
	fmul st0,st0	     ;c0^2
	fld st3 	     ;c8
	fmul st0,st0	     ;c8^2
	fxch st1
	fsub [float_0_5]
	fxch st1
	faddp st1,st0
	fadd st0,st0	     ;*2
	fstp DWORD [eax+4]

	fld st1 	     ;c4
	fmul st0,st3	     ;c4*c8
	fld st1 	     ;c0
	fmul st0,st5	     ;c0*cC
	fxch st1
	fsubrp st1,st0	     ;c4*c8-c0*cC
	fadd st0,st0	     ;*2
	fstp DWORD [eax]

	fmulp st1,st0	     ;c0*c4
	fxch st2
	fmulp st1,st0	     ;c8*cC
	fxch st1
	faddp st1,st0	     ;c0*c4+c8*cC
	fadd st0,st0	     ;*2
	fstp DWORD [eax+8]

ret 8

;============================================================
GetInstancePhysicsVelocity:  ;includes rotation speed
;============================================================
;unlike EXE, returns TRUE if object is active and NULL if
;default values were returned.

     mov edx,[GETOBJPHYSICSOBJADDR]
     push DWORD [esp+8]
     mov ecx,[edx]
     call [GETOBJPHYSICSINDEXPROC]
     test eax,eax
	  jl GetInstancePhysicsVelocity_OBJStill

     cmp [EXEID],'DEMO'
	 jnz GetInstancePhysicsVelocityFV_2
     mov ecx,eax		   ;for DEMO EXE
     shl ecx,5
     add ecx,eax
     lea eax,[eax+8*ecx]
     shl eax,4
     jmp GetInstancePhysicsVelocityDEMO_2
GetInstancePhysicsVelocityFV_2:
     mov ecx,eax		   ;for full version EXEs
     shl ecx,6
     add ecx,eax
     lea edx,[eax+2*ecx]
     lea eax,[eax+8*edx]
     shl eax,2
GetInstancePhysicsVelocityDEMO_2:
     add eax,[OBJPHYSICSBASEADDR]

     push edi
     push esi
     mov edi,[esp+12]
     lea esi,[eax+4]
     mov ecx,7
     CurrentInstanceVelocitySetLoop:
     mov eax,[esi]
     mov [edi],eax
     add esi,0Ch
     add edi,4				;7 values are at 0Ch intervals
     loop CurrentInstanceVelocitySetLoop
     pop esi
     pop edi

mov eax,1
ret 8

GetInstancePhysicsVelocity_OBJStill:
     push edi
     mov edi,[esp+8]
     mov eax,0.000000		  ;same as EXE, but assigns 0.000000 instead of
     mov ecx,7			  ;1.000000 to Wquat velocity value *
     rep stosd
     mov edx,[esp+8]
     pop edi
     ;mov DWORD [edx+12],1.000000
xor eax,eax
ret 8

;* Theoretically, the value 1.000000 should be the correct one,
;because it is part of the zero-rotation local quaternion (includingcosine of 0). However,
;due to the way the values are set when an object is first moved
;from a frozen state, it must be set to 0.000000 to avoid giving
;the object an initial rotation, despite possibly inexact math.

;============================================================
SetInstancePhysicsUnfreezeOnly:
;============================================================
     mov eax,[esp+04h]
     push [SETOBJPHYSICSOBJPARAM]
     mov edx,[ecx]
     push 0
     push eax
     call DWORD [edx+18h]	     ;unfreeze object/enable object physics

ret 8

;============================================================
SetInstancePhysicsVelocity:  ;includes rotation speed
;============================================================
;This is same as the [+44h] method used by ActionType 10 to set [X,Y,Z]
;velocity, except will also set quaternion rotation velocity.
;[esp+4] = instance
;[esp+8] = address of 7 velocity values
;ecx = physics sub-instance of instance [[instance+28h]+0Ch]
;Note: The DEMO executable finds the base address of the velocity
;      using different calculations than the full-version 1.1 EXEs.

push edi
push esi

     mov edi,[esp+0Ch]
     push [SETOBJPHYSICSOBJPARAM]
     mov edx,[ecx]
     push 0
     push edi
     call DWORD [edx+18h]	     ;unfreeze object/enable object physics

     mov edx,[GETOBJPHYSICSOBJADDR]
     push edi
     mov ecx,[edx]
     call [GETOBJPHYSICSINDEXPROC]   ;ecx = sub-instance, already set

     cmp [EXEID],'DEMO'
	 jnz GetInstancePhysicsVelocityFV
     mov ecx,eax		   ;for DEMO EXE
     shl ecx,5
     add ecx,eax
     lea eax,[eax+8*ecx]
     shl eax,4
     jmp GetInstancePhysicsVelocityDEMO
GetInstancePhysicsVelocityFV:
     mov ecx,eax		   ;for full version EXEs
     shl ecx,6
     add ecx,eax
     lea edx,[eax+2*ecx]
     lea eax,[eax+8*edx]
     shl eax,2
GetInstancePhysicsVelocityDEMO:
     add eax,[OBJPHYSICSBASEADDR]

     mov esi,[esp+16]
     lea edi,[eax+4]
     mov ecx,7
     CurrentInstanceVelocityGetLoop:
     mov eax,[esi]
     mov [edi],eax
     add esi,4
     add edi,0Ch			  ;7 values are at 0Ch intervals
     loop CurrentInstanceVelocityGetLoop

pop esi
pop edi
ret 8

;============================================================
VectorDotProduct_STD:	;performs: (vector1 -dot product- vector2)/
;============================================================
;ecx = pointer to source vector [x,y,z]
;edx = pointer to dest./directional vector [x,y,z]
;eax = address of 1 variable to contain vector value (signed, float)

     fld DWORD [edx]	    ;begin dot product
     fmul DWORD [ecx]
     fld DWORD [edx+4]
     fmul DWORD [ecx+4]
     fld DWORD [edx+8]
     fmul DWORD [ecx+8]
     faddp
     faddp		    ;end dot product
     fstp DWORD [eax]

ret

;============================================================
FDConvAnglesToQuat_STD:        ;converts two rotation angles to a quat
;============================================================
;ecx = pointer to 2 angle rotation values already converted to radians (x,z) (y calculated from x)
;      x component = angle with positive side of y axis (will be negated)
;      z component = angle with x-y plane
;[esp+4] = pointer to 4 DWORD struc to receive (implicitely normalized) quat wxyz

sub esp,36

      mov eax,[ecx]
      mov edx,esp
      mov [esp+32],eax
      add ecx,4
      call ToLocalQuat_AxisX_NoNorm   ;calculate z rotation quat (around x axis)

      fld DWORD [esp+32]
      lea ecx,[esp+32]
      fchs
      lea edx,[esp+16]
      fstp DWORD [ecx]
      call ToLocalQuat_AxisZ_NoNorm   ;calculate x rotation quat (around z axis)

      mov ecx,esp
      lea eax,[esp+16]
      mov edx,[esp+36+4]
      call QuaternionMul

add esp,36

ret 4

;============================================================
FacingRad2CompToVector_Sub_STD:        ;assumes dest. vector size = 1
;============================================================
;ecx = pointer to 2 angle rotation values already converted to radians (x,z) (y calculated from x)
;      x component = angle with positive side of y axis
;      z component = angle with x-y plane
;edx = pointer to 3 position values [x,y,z] to add vector to
;eax = pointer to distance multiplier
;note: input angles are based on but do not follow the standard facing values. The X component
;      is NOT limited to the -1.000000 to +1.0000000 interval here, which eliminates the need
;      for the y angle (semi-indirectly).
;
;(note2 : fcos of x = same as fsin of y facing for standard facing values)

     fld DWORD [ecx+4]	      ;Z facing
     fsincos		      ;st0 = cos value (vector on X-Y plane), st1 = sin value (Z vector)
     ;fabs
     fmul DWORD [eax]	      ;distance multiplier for vector on X-Y plane from z angle

     fld DWORD [ecx]	      ;X facing
     fsincos

     fld st2		      ;(vector on X-Y plane from fcos of z angle w/distance mul.)*fcos of x
     fmulp
     fsubr DWORD [edx+4]      ;sub from y comp. of vector
     fstp DWORD [edx+4]

     fmulp		      ;(vector on X-Y plane from fcos of z angle w/distance mul.)*fsin of x
     fsubr DWORD [edx]	      ;sub from x comp. of vector
     fstp DWORD [edx]

     fmul DWORD [eax]	      ;distance multiplier*(fsin of z angle)
     fsubr DWORD [edx+8]      ;sub from z comp. of vector
     fstp DWORD [edx+8]

ret

;============================================================
ToLocalQuat_NoNorm_STD:
;============================================================
;ecx=pointer to 4 DWORD struc: angle (rad), x axis, y axis, z axis values
;edx=local_rotation pointer wxyz

     fld DWORD [ecx]
     fmul [float_0_5]
     fsincos
     fstp DWORD [edx]

     fld st0
     fmul DWORD [ecx+4]
     fstp DWORD [edx+4]
     fld st0
     fmul DWORD [ecx+8]
     fstp DWORD [edx+8]

     fmul DWORD [ecx+12]
     fstp DWORD [edx+12]

ret

;============================================================
VectorNormalize_STD:		 ;eax = vector (must not be null)
;============================================================
;not optimized
;eax unchanged

     fld DWORD [eax]
     fmul st0,st0
     fld DWORD [eax+4]
     fmul st0,st0
     fld DWORD [eax+8]
     fmul st0,st0
     faddp st1,st0
     faddp st1,st0
     fsqrt

     fdivr [float_one]

     fld DWORD [eax]
     fmul st0,st1
     fstp DWORD [eax]

     fld DWORD [eax+4]
     fmul st0,st1
     fstp DWORD [eax+4]

     fld DWORD [eax+8]
     fmulp st1,st0
     fstp DWORD [eax+8]

ret

;============================================================
ResetCCameraPlayerSources:
;============================================================
       mov edx,[LocationADDR]
       mov eax,[PLAYER_OBJ_INVUL_ADDR]
       mov edx,[edx]
       mov eax,[eax]
       mov ecx,[edx+14h]		 ;get CCamera object
       mov [ecx+50h],eax
       mov [ecx+54h],eax
ret

;============================================================
SpanResize24BitColor:
;============================================================
;[esp+4] = color to convert
;[esp+8] = new color span (maximum color value)
;destroys NO registers except eax (= result)
;NOT OPTIMIZED
;This function will convert a color from a 00FFFFFFh 256-color value component
;to a 00RRGGBBh RR/GG/BB-color value format, where each color component is less or equal to
;0FFh. If all color components are the same, this will cause the
;color simply to diminish in intensity and keep its original proportionality.
;[esp+8] represents the maximum possible color value.

push ecx
push edx

       mov ecx,[esp+12]
       mov edx,[esp+16]
       call SpanResize8BitColor
       mov eax,ecx

       mov ecx,[esp+12]
       mov edx,[esp+16]
       shr ecx,8
       shr edx,8
       call SpanResize8BitColor
       shl ecx,8
       or eax,ecx

       mov ecx,[esp+12]
       mov edx,[esp+16]
       shr ecx,16
       shr edx,16
       call SpanResize8BitColor
       shl ecx,16
       or eax,ecx

pop edx
pop ecx
ret 8

;============================================================
SpanResize8BitColor:	;cl = color to convert, dl = max span -> result in ecx (cl)
;============================================================
;destroyed: ecx, edx

       and ecx,0FFh
       and edx,0FFh
       push ecx
       push edx
       fild DWORD [esp+4]		;cl/255 = new/maxspan -> new = (cl/255)*maxspan)
       fmul [float_1div255]
       fild DWORD [esp]
       fmulp
       fistp DWORD [esp]
       add esp,8
       mov cl,[esp-8]

ret

;============================================================
;Limited Quaternion multiplication (eax=q1, ecx=q2, edx=result)
;============================================================
;supposes second quaternion is rotation around x axis only (y2 and z2 null)
;eax = source quat (all valid)
;ecx = around-x quat
;w2 = non-zero
;x2 = non-zero
;y2 = null
;z2 = null

;(Q1 * Q2).w = (w1w2 - x1x2)
;(Q1 * Q2).x = (w1x2 + x1w2)
;(Q1 * Q2).y = (y1w2 + z1x2)
;(Q1 * Q2).z = (z1w2 - y1x2)

QuaternionMulLocalQ2AxisX_STD:	      ;eax=q1 , ecx=q2, edx=new quat
;------------- w

	fld [w1]
	fmul [w2]

	fld [x1]
	fmul [x2]
	fsubp st1,st0

	fstp DWORD [edx]

;------------- x
	fld [w1]
	fmul [x2]

	fld [x1]
	fmul [w2]
	faddp st1,st0

	fstp DWORD [edx+4]

;------------- y

	fld [y1]
	fmul [w2]

	fld [z1]
	fmul [x2]
	faddp st1,st0
	fstp DWORD [edx+8]

;------------- z

	fld [z1]
	fmul [w2]

	fld [y1]
	fmul [x2]

	fsubp st1,st0
	fstp DWORD [edx+12]

ret

;============================================================
CCameraTeleport:	;edx = pointer to 3 location values (y,x,z) and 4 quat values (w,x,y,z)
;============================================================
;destroyed: eax,ecx,edx
;If members DWORD [CCamera+50h] and DWORD [CCamera+54h] are CPlayerPriv objects,
;the player object will be teleported along with the camera.

       mov eax,[LocationADDR]
       mov eax,[eax]
       mov ecx,[eax+14h]		 ;get CCamera object

       push 0
       mov eax,[ecx]
       push edx
       call DWORD [eax+38h]		 ;set new camera position/orientation

ret

;============================================================
GetInstanceFromStringGlobal:	;eax = pointer to string, returns instance in eax or null if not found
;============================================================
;should not be used in performance-critical areas where
;the second part of this function is to be called repeatedly
;on the same string ID (from the same string)
       test eax,eax
	    jz GetInstanceFromStringGlobal_END

	invoke GETTEMPINST_PROC,eax,0,1    ;returns string ID (case-sensitive, unique)
							  ;params 0 and 1 are standard
	add esp,12
	mov edx,[LocationADDR]
	push eax
	mov ecx,[edx]
	call [GETOBJFROMSTRINGIDPROC]	    ;this fetched the string ID's associated instance, if existing

GetInstanceFromStringGlobal_END:
ret

;============================================================
GetCAnimalInstanceCount:      ;returns count in eax (for current level)
;============================================================
	mov eax,[DINOS_OBJECT]
	mov eax,[eax]
	mov eax,[eax+0000319Ch]
ret

;============================================================
VectorMagnitude_STD:	      ;eax = pointer to vector, edx = pointer for result
;============================================================

     fld DWORD [eax]
     fmul st0,st0
     fld DWORD [eax+4]
     fmul st0,st0
     fld DWORD [eax+8]
     fmul st0,st0
     faddp st1,st0
     faddp st1,st0
     fsqrt
     fstp DWORD [edx]

ret


